<template>
  <div>
    <v-card-title>
      Поступающие
      <v-spacer></v-spacer>
      <v-text-field
        v-model="search"
        append-icon="mdi-magnify"
        label="Поиск"
        single-line
        hide-details
      ></v-text-field>
    </v-card-title>
    <v-card-subtitle>Всего мест: {{ placesCount }}</v-card-subtitle>
    <v-data-table
      :headers="headers"
      :items="content"
      :search="search"
      multi-sort
    >
    <template v-slot:item.hasOriginalDocument="{ item }">
      <v-simple-checkbox
        v-model="item.hasOriginalDocument"
        disabled
      ></v-simple-checkbox>
    </template>
    <template v-slot:item.hasAccepted="{ item }">
      <v-simple-checkbox
        v-model="item.hasAccepted"
        disabled
      ></v-simple-checkbox>
    </template>
    <template v-slot:item.rank="{ item }">
      <v-chip
        :color="getColor(item.rank)"
        dark
      >
        {{ item.rank }}
      </v-chip>
    </template>
    </v-data-table>
  </div>
</template>

<script lang="ts">
import { Code, IAbiturientRate, IAbiturientScore, ISubject } from '@/interfaces';
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';

@Component
export default class RateTable extends Vue {
  @Prop() public rates!: IAbiturientRate[];
  @Prop() public requiredSubjects!: ISubject[];
  @Prop() public placesCount!: number;

  private search = '';

  public get headers() {
    const fields = [...[
      {name: '№', code: 'rank'},
      {name: 'ФИО', code: 'username'},
      {name: 'Сумма', code: 'sum'},
      ...this.requiredSubjects,
      {name: 'Оригинал', code: 'hasOriginalDocument'},
      {name: 'Зачислен', code: 'hasAccepted'},
    ]];
    return fields.flatMap((x: Code) => new Object({text: x.name, value: x.code}));
  }

  public getColor(rank: number): string {
    if (rank > this.placesCount) {
      return 'orange';
    }
    return 'green';
  }

  public get content() {
    return this.rates.flatMap((x: IAbiturientRate) => {
      const obj: any = {
        username: x.username,
        hasOriginalDocument: x.hasOriginalDocument,
        hasAccepted: x.hasAccepted,
        rank: x.rank,
      };

      let sum = 0;
      x.score.flatMap((y: IAbiturientScore) => {
        obj[y.code] = y.value;
        sum +=  y.code === 'username' ? 0 : y.value;
      });
      obj.sum = sum;
      return obj;
    });

  }
}
</script>
